package com.example.simplevideoupload;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;

import com.vaadin.server.Page;
import com.vaadin.server.VaadinService;
import com.vaadin.server.VaadinSession;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Upload.Receiver;
import com.vaadin.ui.Upload.SucceededEvent;
import com.vaadin.ui.Upload.SucceededListener;

public class FileUploader implements Receiver, SucceededListener {
	
	private static final long serialVersionUID = 1L;
	private File file = null;
	private UploadComponent CallingUIComp = null;
	private VaadinSession vSess = null;
	private String MimeType = null;

	public FileUploader(UploadComponent uiComp,VaadinSession vsess) {
		super();
		CallingUIComp = uiComp;
		vSess = vsess;
	}

	/* (non-Javadoc)
	 * @see com.vaadin.ui.Upload.SucceededListener#uploadSucceeded(com.vaadin.ui.Upload.SucceededEvent)
	 */
	@Override
	public void uploadSucceeded(SucceededEvent event) {
	
		CallingUIComp.showUploadedFile(file.getAbsolutePath()); // 2016-12-16
		
	}

	/* (non-Javadoc)
	 * @see com.vaadin.ui.Upload.Receiver#receiveUpload(java.lang.String, java.lang.String)
	 */
	@Override
	public OutputStream receiveUpload(String filename, String mimeType) {
		
		MimeType = mimeType;

		CallingUIComp.prepareUpload();
		
		FileOutputStream fos = null;
		
		if(filename == null || filename.trim().isEmpty())
		{
			new Notification("Error", "file name missing", Notification.Type.ERROR_MESSAGE).show(Page.getCurrent());
		} else {

			try {
	
				String basepath = VaadinService.getCurrent().getBaseDirectory().getAbsolutePath();
				long now = System.currentTimeMillis();
				
				file = new File(basepath + "\\tmp\\" + vSess.getSession().getId() + now + "_" + filename );
				fos = new FileOutputStream(file);
			} catch (final java.io.FileNotFoundException e) {
				new Notification("Error" + " " + e.getMessage(), Notification.Type.ERROR_MESSAGE).show(Page.getCurrent());
			}
		}
		return fos; // Return output stream

	}

	/**
	 * @return the file
	 */
	public File getFile() {
		return file;
	}

	public String getMimeType() {
		return MimeType;
	}
}
